export interface ServiceContainer {
    add(name: string, type: any): ServiceCollectionBuilder;
    addWith(name: string, mapfn: (provider: ServiceProvider) => any): ServiceCollectionBuilder;
    build(): ServiceProvider;
    use(fn: (container: ServiceContainer) => void): ServiceContainer;
}
export interface ServiceCollectionBuilder {
    scoped(): ServiceCollectionBuilder;
    transient(): ServiceCollectionBuilder;
    singleton(): ServiceCollectionBuilder;
    args(...args: string[]): ServiceCollectionBuilder;
}
export interface ServiceProvider {
    get<T>(name: string): T;
    clone(): ServiceProvider;
}
export declare class ServiceContainerImp implements ServiceContainer {
    private settings;
    constructor();
    add(name: string, type: any): ServiceCollectionBuilder;
    addWith(name: string, mapfn: (provider: ServiceProvider) => any): ServiceCollectionBuilder;
    use(fn: (container: ServiceContainer) => void): ServiceContainer;
    /**
     * @returns {ServiceProvider}
     */
    build(): ServiceProvider;
}
