"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.visitor = exports.SourceCallType = exports.CallExpressionType = exports.Operator = exports.ExpressionType = void 0;
var ExpressionType;
(function (ExpressionType) {
    ExpressionType["binary"] = "binary";
    ExpressionType["call"] = "call";
    ExpressionType["property"] = "property";
    ExpressionType["constant"] = "constant";
    ExpressionType["sourceCall"] = "sourceCall";
    ExpressionType["callChain"] = "callChain";
})(ExpressionType = exports.ExpressionType || (exports.ExpressionType = {}));
var Operator;
(function (Operator) {
    Operator["eq"] = "eq";
    Operator["ne"] = "ne";
    Operator["lt"] = "lt";
    Operator["lte"] = "lte";
    Operator["gt"] = "gt";
    Operator["gte"] = "gte";
    Operator["or"] = "or";
    Operator["and"] = "and";
})(Operator = exports.Operator || (exports.Operator = {}));
var CallExpressionType;
(function (CallExpressionType) {
    CallExpressionType["startsWith"] = "startsWith";
    CallExpressionType["endsWith"] = "endsWith";
    CallExpressionType["contains"] = "contains";
    CallExpressionType["equal"] = "equal";
    CallExpressionType["in"] = "in";
    CallExpressionType["any"] = "any";
    CallExpressionType["all"] = "all";
    CallExpressionType["elemMatch"] = "elemMatch";
    CallExpressionType["size"] = "size";
    CallExpressionType["exists"] = "exists";
})(CallExpressionType = exports.CallExpressionType || (exports.CallExpressionType = {}));
var SourceCallType;
(function (SourceCallType) {
    SourceCallType["filter"] = "filter";
    SourceCallType["first"] = "first";
    SourceCallType["sort"] = "sort";
    SourceCallType["skip"] = "skip";
    SourceCallType["take"] = "take";
    SourceCallType["select"] = "select";
    SourceCallType["count"] = "count";
})(SourceCallType = exports.SourceCallType || (exports.SourceCallType = {}));
function visitor() {
    return {
        visit: function (expression) {
            if (expression == null) {
                throw new Error('expression could not null');
            }
            switch (expression.type) {
                case ExpressionType.binary:
                    return this.binary(expression);
                case ExpressionType.property:
                    return this.property(expression);
                case ExpressionType.call:
                    return this.call(expression);
                case ExpressionType.constant:
                    return this.constant(expression);
                case ExpressionType.sourceCall:
                    return this.sourceCall(expression);
                case ExpressionType.callChain:
                    return this.callChain(expression);
                default:
                    throw new Error(expression.type + ' could not find');
            }
        },
        binary: () => { },
        property: () => { },
        call: () => { },
        constant: () => { },
        sourceCall: () => { },
        callChain: () => { }
    };
}
exports.visitor = visitor;
