"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createQuery = exports.Visitor = void 0;
class Visitor {
    visit(o) {
        switch (o.type) {
            case 'composite':
                return this.composite(o);
            case 'eq':
                return this.eq(o);
            case 'filter':
                return this.filter(o);
            case 'order':
                return this.order(o);
            case 'page':
                return this.page(o);
            case 'qr':
                return this.qr(o);
            case 'key':
                return this.key(o);
            case 'range':
                return this.range(o);
            case 'or':
                return this.or(o);
            default:
                throw new Error(o.type);
        }
    }
    ;
    eq(eq) {
    }
    composite(composite) {
    }
    filter(filter) {
    }
    ;
    order(order) {
    }
    ;
    page(page) {
    }
    ;
    qr(qr) {
    }
    ;
    key(key) {
    }
    ;
    range(range) {
    }
    ;
    or(or) {
    }
}
exports.Visitor = Visitor;
function addFilter(o, newFilter) {
    return createQuery(Object.assign(Object.assign({}, o), { filter: {
            type: 'filter',
            filters: [...(o.filter.filters || []), newFilter]
        } }));
}
;
function removeFilter(o, name, value) {
    return createQuery(Object.assign(Object.assign({}, o), { filter: {
            type: 'filter',
            filters: (o.filter.filters || []).map(e => {
                if (e["name"] !== name) {
                    return e;
                }
                if (e["values"] != null) {
                    if (e["values"].indexOf(value) >= 0) {
                        return Object.assign(Object.assign({}, e), { values: e["values"].filter(v => v != value) });
                    }
                }
                if (e["value"] === value) {
                    return null;
                }
                return e;
            }).filter(o => o != null)
        } }));
}
function removeFilterAll(o, name) {
    return createQuery(Object.assign(Object.assign({}, o), { filter: {
            type: 'filter',
            filters: [...(o.filter.filters || []).filter(e => {
                    let exists = e["name"] === name;
                    return !exists;
                })]
        } }));
}
function createQuery(o = null) {
    o = o || {
        filter: {
            type: 'filter',
            filters: []
        }
    };
    return Object.assign(Object.assign({ type: 'composite' }, o), { eq(name, value) {
            return addFilter(this, {
                type: 'eq',
                name,
                value
            });
        },
        range(name, begin, end) {
            return addFilter(this, {
                type: 'range',
                name,
                begin,
                end
            });
        },
        contains(name, values) {
            return addFilter(this, {
                type: 'or',
                name,
                values
            });
        },
        any(name, value) {
            return ((o.filter || {}).filters || []).some((e) => {
                return e["name"] == name && (Array.from(e["values"] || []).indexOf(value) >= 0 || e["value"] === value);
            });
        },
        exists(name) {
            return ((o.filter || {}).filters || []).some((e) => {
                return e["name"] == name;
            });
        },
        remove(name, value) {
            return removeFilter(this, name, value);
        },
        removeAll(name) {
            return removeFilterAll(this, name);
        } });
}
exports.createQuery = createQuery;
