import { Expression, SourceCallExpression } from "./expressions";
export interface Queryable {
    expression: Expression;
    query(...expression: Expression[]): Queryable;
    memorize(): Promise<any>;
}
export declare class ArrayQueryable implements Queryable {
    expression: Expression;
    source: Iterable<any>;
    constructor(source: Iterable<any>, expression?: any);
    query(...expressions: Expression[]): Queryable;
    memorize(): Promise<any>;
    [Symbol.iterator](): any;
    cursor(): {
        next: () => {
            done: boolean;
            value?: any;
        };
    };
}
export declare function queryable(source: Iterable<any>): Queryable;
export declare function decorate(queryable: Queryable, sets: {
    query?: (queryable: Queryable) => Queryable;
    memorize?: (querable: Queryable) => Promise<any>;
}): Queryable;
export declare function escapeCallChain(expressions: any): Array<SourceCallExpression>;
export declare function getSize(expression: Expression): any;
