"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toNextIterator = exports.checkObject = void 0;
function checkObject(value) {
    if (typeof value === 'object') {
        if (value instanceof Date)
            return false;
        return true;
    }
}
exports.checkObject = checkObject;
function toNextIterator(array, e, resultFn) {
    let iterator = function (arg, resolve) {
        let current = -1;
        let next = function () {
            current++;
            if (current === array.length) {
                resolve();
                return;
            }
            e.next = next;
            array[current](arg, {
                next,
                done: function (e) {
                    resolve(e);
                },
            });
        };
        return next();
    };
    return iterator(e, resultFn);
}
exports.toNextIterator = toNextIterator;
